if Fence:HasModule('SinglePrice') then return end

local L = AceLibrary("AceLocale-2.2"):new("Fence_SinglePrice")
local l = AceLibrary("AceLocale-2.2"):new("Fence")
local abc = AceLibrary("Abacus-2.0")

-- Localization
L:RegisterTranslations("enUS", function() return {
		["Single Price"] = true,
		["Show Bid"] = true,
		["Text Style"] = true,
		["Change single price style."] = true,
		["Bid"] = true,
        ["Change bid style."] = true,
        ["Bid Style"] = true,
	}
end)

L:RegisterTranslations("deDE", function() return {
		["Single Price"] = "Single Price",
		["Show Bid"] = "Gebotanzeige",
		["Text Style"] = "Einzelpreisstil",
		["Change single price style."] = "Stil f\195\188r Einzelpreis anpassen.",
		["Bid"] = "Gebot",
        ["Change bid style."] = "Stil f\195\188r Gebote anpassen.",
        ["Bid Style"] = "Gebotstil"
	}
end)

Fence_SinglePrice = Fence:NewModule("SinglePrice")
	
	function Fence_SinglePrice:OnInitialize()
		self.db = Fence:AcquireDBNamespace("SinglePrice")
		if self.db.profile.showBid == nil then self.db.profile.showBid = true end
		if self.db.profile.style == nil then self.db.profile.style = "short" end
        if self.db.profile.bidStyle == nil then self.db.profile.bidStyle = "fade" end


		
		Fence.options.args.singleprice = {
			type = 'group',
			name = L["Single Price"], aliases='sp',
			desc = string.format(l["%s options"], L["Single Price"]),
				args = {
					toggle = {
						type = 'toggle',
						name = L["Single Price"],
						desc = string.format(l["Toggles %s function."], L["Single Price"]),
						get = function() return Fence:IsModuleActive("SinglePrice") end,
						set = function(v) Fence:ToggleModuleActive("SinglePrice", v) end
					},
					textstyle= {
						type = 'text',
						name = L["Text Style"], 
						desc = L["Change single price style."],
						get = function() return self.db.profile.style end,
						set = function(v) self.db.profile.style= v end,
						validate = {"short", "full", "condensed"}
					},
					showbid = {
						type = 'toggle',
						name = L["Show Bid"], aliases='sb',
						desc = string.format(l["Toggles %s function."], L["Show Bid"]),
						get = function() return self.db.profile.showBid end,
						set = function(v) self.db.profile.showBid = v end
					},
  					bidstyle = {
						type = 'text',
						name = L["Bid Style"], aliases='bs',
						desc = L["Change bid style."],
						get = function() return self.db.profile.bidStyle end,
						set = function(v) self.db.profile.bidStyle= v end,
                        validate = {"text", "fade"}
					}
				}
			}
	end

	function Fence_SinglePrice:OnEnable()
		self:RegisterEvent("AH_LOADED")
	end

	function Fence_SinglePrice:OnDisable()
		if self:IsHooked("AuctionFrameBrowse_Update") then self:Unhook("AuctionFrameBrowse_Update") end
	end

	function Fence_SinglePrice:AH_LOADED()
		self:Hook("AuctionFrameBrowse_Update", true)
		self:UnregisterEvent("AH_LOADED")
	end
	
	function Fence_SinglePrice:AuctionFrameBrowse_Update()
		self.hooks["AuctionFrameBrowse_Update"]()

		local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
		local index, button, buttonName 
		local bidText

		for i=1, NUM_BROWSE_TO_DISPLAY do
			index = offset + i + (NUM_AUCTION_ITEMS_PER_PAGE * AuctionFrameBrowse.page)
			local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("list", offset + i)
			if name ==nil then return end
			
			bidText = ""
			buttonName = "BrowseButton"..i
			local itemName = getglobal(buttonName.."Name")		

			if (buyoutPrice > 0 ) and (count > 1) then
				local ep = floor(buyoutPrice/count)
				if strlen(name) > 20 then name = strsub(name,0,20).."..." end
				if bidAmount > 0 and self.db.profile.showBid then 
                    if self.db.profile.bidStyle == "text" then
                        bidText = "- |cffffff00" .. L["Bid"] .. "|r"
                    else
                        local moneyFrame = getglobal(buttonName.."MoneyFrame")
                        moneyFrame:SetAlpha(.5)
                    end
                end
				local spText, spMoney
				if self.db.profile.style == "short" then
					spMoney = abc:FormatMoneyShort(ep, true)
				elseif self.db.profile.style == "full" then
					spMoney = abc:FormatMoneyFull(ep, true)
				elseif self.db.profile.style == "condensed" then
					spMoney = abc:FormatMoneyCondensed(ep, true)
				end
				spText = string.format("%s (%s) %s",name,spMoney, bidText)
				itemName:SetText(spText)
			else
				if bidAmount > 0 and self.db.profile.showBid then 
					if strlen(name) > 20 then name = strsub(name,0,20).."..." end
					name = name .. " - |cffffff00" .. L["Bid"] .. "|r" 
					itemName:SetText(name)
				end	
			end
		end 
	end
	
